cgroup	GROUP	code_seg, data_seg
	ASSUME	cs:cgroup, ds:cgroup
code_seg SEGMENT PUBLIC
;
; 뢮  ࠭ ᥪ
	PUBLIC	init_sec_disp
	EXTRN	write_pattern:NEAR, send_crlf:NEAR
	EXTRN	goto_xy:NEAR, write_phantom:NEAR
data_seg SEGMENT PUBLIC
	EXTRN	lines_before_sector:BYTE
	EXTRN	sector_offset:WORD
data_seg ENDS
init_sec_disp PROC NEAR
	push	dx
	xor	dl,dl
	mov	dh,lines_before_sector
	call	goto_xy
	call	write_top_hex_numbers
	lea	dx,top_line_pattern
	call	write_pattern
	call	send_crlf
	xor	dx,dx
	mov	sector_offset,dx
	call	disp_half_sector
	lea	dx,bottom_line_pattern
	call	write_pattern
	call	write_phantom
	pop	dx
	ret
init_sec_disp ENDP
	EXTRN	write_char_n_times:NEAR
	EXTRN	write_char:NEAR, write_hex:NEAR
	EXTRN	write_hex_digit:NEAR, send_crlf:NEAR
;
;   0 - f  孥  ࠭
write_top_hex_numbers PROC NEAR
	push	cx
	push	dx
	mov	dl,' '
	mov	cx,9
	call	write_char_n_times
	xor	dh,dh
hex_number_loop:
	mov	dl,dh
	call	write_hex
	mov	dl,' '
	call	write_char
	inc	dh
	cmp	dh,10h
	jb	hex_number_loop
	mov	dl,' '
	mov	cx,2
	call	write_char_n_times
	xor	dl,dl
hex_digit_loop:
	call	write_hex_digit
	inc	dl
	cmp	dl,10h
	jb	hex_digit_loop
	call	send_crlf
	pop	dx
	pop	cx
	ret
write_top_hex_numbers ENDP
;
; 뢮  ࠭ ᥪ
; 室 dx - ᬥ饭  ᥪ
;  , ⭮ 16
	PUBLIC	disp_half_sector
	EXTRN	send_crlf:NEAR
disp_half_sector PROC NEAR
	push	cx
	push	dx
	mov	cx,16
half_sector:
	call	disp_line
	call	send_crlf
	add	dx,16
	loop	half_sector
	pop	dx
	pop	cx
	ret
disp_half_sector ENDP
;
; 뢮 ப ᥪ
; 室 dx - ᬥ饭  ᥪ  
	PUBLIC	disp_line
	EXTRN	write_hex:NEAR, write_char:NEAR
	EXTRN	write_char_n_times:NEAR
disp_line PROC NEAR
	push	bx
	push	cx
	push	dx
	mov	bx,dx
	mov	dl,' '
	mov	cx,3
	call	write_char_n_times
	cmp	bx,100h
	jb	write_one
	mov	dl,'1'
write_one:
	call	write_char
	mov	dl,bl
	call	write_hex
	mov	dl,' '
	call	write_char
	mov	dl,''
	call	write_char
	mov	dl,' '
	call	write_char
	mov	cx,16
	push	bx
hex_loop:
	mov	dl,sector[bx]
	call	write_hex
	mov	dl,' '
	call	write_char
	inc	bx
	loop	hex_loop
	mov	dl,''
	call	write_char
	mov	dl,' '
	call	write_char
	mov	cx,16
	pop	bx
ascii_loop:
	mov	dl,sector[bx]
	call	write_char
	inc	bx
	loop	ascii_loop
	mov	dl,' '
	call	write_char
	mov	dl,''
	call	write_char
	pop	dx
	pop	cx
	pop	bx
	ret
disp_line ENDP
code_seg ENDS
data_seg SEGMENT PUBLIC
	EXTRN	sector:BYTE
top_line_pattern LABEL BYTE
	DB ' ',7,'',1,'',12,'',1,'',11,'',1,''
	DB 11,'',1,'',12,'',1,'',18,'',1,0
bottom_line_pattern LABEL BYTE
	DB ' ',7,'',1,'',12,'',1,'',11,'',1,''
	DB 11,'',1,'',12,'',1,'',18,'',1,0
data_seg ENDS
	END