cgroup	GROUP	code_seg, data_seg
	ASSUME	cs:cgroup, ds:cgroup
code_seg SEGMENT PUBLIC
data_seg SEGMENT PUBLIC
	EXTRN	sector:BYTE, sector_offset:WORD
	EXTRN	phantom_cursor_x:BYTE
	EXTRN	phantom_cursor_y:BYTE
data_seg ENDS
;
;    sector (室: dl - )
write_to_memory PROC NEAR
	push	ax
	push	bx
	push	cx
	mov	bx,sector_offset
	mov	al,phantom_cursor_y
	xor	ah,ah
	mov	cl,4
	shl	ax,cl
	add	bx,ax
	mov	al,phantom_cursor_x
	xor	ah,ah
	add	bx,ax
	mov	sector[bx],dl
	pop	cx
	pop	bx
	pop	ax
	ret
write_to_memory	ENDP
;
;    sector   ࠭ (室: dl - )
	PUBLIC	edit_BYTE
	EXTRN	save_real_cursor:NEAR
	EXTRN	restore_real_cursor:NEAR
	EXTRN	mov_to_hex_position:NEAR
	EXTRN	mov_to_ascii_position:NEAR
	EXTRN	write_phantom:NEAR, write_char:NEAR
	EXTRN	write_prompt_line:NEAR
	EXTRN	cursor_right:NEAR, write_hex:NEAR
data_seg SEGMENT PUBLIC
	EXTRN	editor_prompt:BYTE
data_seg ENDS
edit_BYTE PROC NEAR
	push	dx
	call	save_real_cursor
	call	mov_to_hex_position
	call	cursor_right
	call	write_hex
	call	mov_to_ascii_position
	call	write_char
	call	restore_real_cursor
	call	write_phantom
	call	write_to_memory
	lea	dx,editor_prompt
	call	write_prompt_line
	pop	dx
	ret
edit_BYTE ENDP
code_seg ENDS
	END