cgroup	GROUP	code_seg, data_seg
	ASSUME	cs:cgroup, ds:cgroup
code_seg SEGMENT PUBLIC
;
; 뢮   16-
; 室: dl - 
	PUBLIC	write_hex
write_hex PROC NEAR
	push	cx
	push	dx
	mov	dh,dl
	mov	cx,4
	shr	dl,cl
	call	write_hex_digit
	mov	dl,dh
	and	dl,0fh
	call	write_hex_digit
	pop	dx
	pop	cx
	ret
write_hex ENDP
;
; ८ࠧ 4   dl
;  뢮  ࠭
; 室: dl - 
	PUBLIC	write_hex_digit
write_hex_digit PROC NEAR
	push	dx
	cmp	dl,10
	jae	hex_letter
	add	dl,"0"
	jmp	SHORT write_digit
hex_letter:
	add	dl,"A"-10
write_digit:
	call	write_char
	pop	dx
	ret
write_hex_digit ENDP
;
; 뢮  ࠭ ᨬ,
;  ᤢ ࠢ
; 室: dl - 
	PUBLIC	write_char
	EXTRN	cursor_right:NEAR
write_char PROC NEAR
	push	ax
	push	bx
	push	cx
	push	dx
	mov	ah,9
	mov	bh,0
	mov	cx,1
	mov	al,dl
	mov	bl,7
	int	10h
	call	cursor_right
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	ret
write_char ENDP
;
; 뢮 16-⭮ ᫮  10 
; 室: dx - ᫮
	PUBLIC	write_decimal
write_decimal PROC NEAR
	push	ax
	push	cx
	push	dx
	push	si
	mov	ax,dx
	mov	si,10
	xor	cx,cx
non_zero:
	xor	dx,dx
	div	si
	push	dx
	inc	cx
	or	ax,ax
	jne	non_zero
write_digit_loop:
	pop	dx
	call	write_hex_digit
	loop	write_digit_loop
end_decimal:
	pop	si
	pop	dx
	pop	cx
	pop	ax
	ret
write_decimal ENDP
;
; 뢮 ᨬ N ࠧ
; 室: dl - 
; cx - ᪮쪮 ࠧ
	PUBLIC	write_char_n_times
write_char_n_times PROC NEAR
	push	cx
n_times:
	call	write_char
	loop	n_times
	pop	cx
	ret
write_char_n_times ENDP
;
; 뢮 ப  ᮮ⢥⢨  ଠ⮬:
; <ᨬ>,<⢮>,...,0
; dx - 
	PUBLIC	write_pattern
write_pattern PROC NEAR
	push	ax
	push	cx
	push	dx
	push	si
	pushf
	cld
	mov	si,dx
pattern_loop:
	lodsb
	or	al,al
	jz	end_pattern
	mov	dl,al
	lodsb
	mov	cl,al
	xor	ch,ch
	call	write_char_n_times
	jmp	SHORT pattern_loop
end_pattern:
	popf
	pop	si
	pop	dx
	pop	cx
	pop	ax
	ret
write_pattern ENDP
;
; 뢮  ᪮  ᥪ
	PUBLIC	write_header
data_seg SEGMENT PUBLIC
	EXTRN	header_line_no:BYTE
	EXTRN	header_part_1:BYTE
	EXTRN	header_part_2:BYTE
	EXTRN	disk_drive_no:BYTE
	EXTRN	current_sector_no:WORD
data_seg ENDS
	EXTRN	goto_xy:NEAR
	EXTRN	clear_to_end_of_line:NEAR
write_header PROC NEAR
	push	cx
	push	dx
	xor	dl,dl
	mov	dh,header_line_no
	call	goto_xy
	lea	dx,header_part_1
	call	write_string
	mov	dl,disk_drive_no
	add	dl,'A'
	call	write_char
	lea	dx,header_part_2
	call	write_string
	mov	dx,current_sector_no
	call	write_decimal
	call	clear_to_end_of_line
	mov	dh,header_line_no
	mov	dl,5
	call	goto_xy
	mov	cx,1
	mov	dl,94
	call	write_attribute_n_times
	mov	dl,15
	call	goto_xy
	mov	cx,4
	mov	dl,90
	call	write_attribute_n_times
	pop	dx
	pop	cx
	ret
write_header ENDP
;
; 뢮  ࠭ ப
; ( 稢  0)
; dx -  ப
	PUBLIC	write_string
write_string PROC NEAR
	push	ax
	push	dx
	push	si
	pushf
	cld
	mov	si,dx
string_loop:
	lodsb
	or	al,al
	jz	end_of_string
	mov	dl,al
	call	write_char
	jmp	SHORT string_loop
end_of_string:
	popf
	pop	si
	pop	dx
	pop	ax
	ret
write_string ENDP
;
; 뢮  ࠭ ப ਣ襭
; dx -  ப
	PUBLIC	write_prompt_line
	EXTRN	clear_to_end_of_line:NEAR
	EXTRN	goto_xy:NEAR
data_seg SEGMENT PUBLIC
	EXTRN	prompt_line_no:BYTE
data_seg ENDS
write_prompt_line PROC NEAR
	push	dx
	xor	dl,dl
	mov	dh,prompt_line_no
	call	goto_xy
	pop	dx
	call	write_string
	call	clear_to_end_of_line
	ret
write_prompt_line ENDP
;
; ⠭ ਡ  ᪮쪨
; ᨬ, 稭  樨 
; dl - ਡ, cx - ᫮ ᨬ
	PUBLIC	write_attribute_n_times
	EXTRN	cursor_right:NEAR
write_attribute_n_times PROC NEAR
	push	ax
	push	bx
	push	cx
	push	dx
	mov	bl,dl
	xor	bh,bh
	mov	dx,cx
	mov	cx,1
attr_loop:
	mov	ah,8
	int	10h
	mov	ah,9
	int	10h
	call	cursor_right
	dec	dx
	jnz	attr_loop
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	ret
write_attribute_n_times ENDP
;
; ⠥ 梥⭮   
	PUBLIC	menu_line
	EXTRN	goto_xy:NEAR
data_seg SEGMENT PUBLIC
string4	DB	'  ',0
string3 DB	'F1-।騩 F2-騩 F3-᪮'
	DB	' F4-⥭ F5- F10-室',0
data_seg ENDS
menu_line PROC NEAR
	push	cx
	push	dx
	xor	dh,dh
	mov	dl,23
	push	dx
	call	goto_xy
	lea	dx,string4
	call	write_string
	pop	dx
	call	goto_xy
	mov	dl,107
	mov	cx,31
	call	write_attribute_n_times
	mov	dh,24
	mov	dl,6
	call	goto_xy
	lea	dx,string3
	call	write_string
	mov	dh,24
	mov	dl,6
	call	goto_xy
	mov	cx,3
	mov	dl,12
	call	write_attribute_n_times
	mov	dl,20
	call	goto_xy
	mov	dl,12
	call	write_attribute_n_times
	mov	dl,33
	call	goto_xy
	mov	dl,12
	call	write_attribute_n_times
	mov	dl,45
	call	goto_xy
	mov	dl,12
	call	write_attribute_n_times
	mov	dl,55
	call	goto_xy
	mov	dl,12
	call	write_attribute_n_times
	mov	cx,4
	mov	dl,65
	call	goto_xy
	mov	dl,12
	call	write_attribute_n_times
	mov	cx,10
	mov	dl,9
	call	goto_xy
	mov	dl,46
	call	write_attribute_n_times
	mov	cx,9
	mov	dl,23
	call	goto_xy
	mov	dl,46
	call	write_attribute_n_times
	mov	cx,8
	mov	dl,36
	call	goto_xy
	mov	dl,46
	call	write_attribute_n_times
	mov	cx,6
	mov	dl,48
	call	goto_xy
	mov	dl,46
	call	write_attribute_n_times
	mov	dl,58
	call	goto_xy
	mov	dl,46
	call	write_attribute_n_times
	mov	cx,5
	mov	dl,69
	call	goto_xy
	mov	dl,46
	call	write_attribute_n_times
	pop	dx
	pop	cx
	ret
menu_line ENDP
code_seg ENDS
	END