cgroup	GROUP	code_seg, data_seg
	ASSUME	cs:cgroup, ds:cgroup
code_seg SEGMENT PUBLIC
;
; ८ࠧ  㪢  
; 室: dx -   ப
	PUBLIC	string_to_upper
string_to_upper PROC NEAR
	push	ax
	push	bx
	push	cx
	mov	bx,dx
	inc	bx
	mov	cl,[bx]
	xor	ch,ch
upper_loop:
	inc	bx
	mov	al,[bx]
	cmp	al,'a'
	jb	not_lower
	cmp	al,'z'
	ja	not_lower
	add	al,'A'-'a'
	mov	[bx],al
not_lower:
	loop	upper_loop
	pop	cx
	pop	bx
	pop	ax
	ret
string_to_upper ENDP
convert_hex_digit PROC NEAR
	cmp	al,'0'
	jb	bad_digit
	cmp	al,'9'
	ja	try_hex
	sub	al,'0'
	clc
	ret
try_hex:
	cmp	al,'A'
	jb	bad_digit
	cmp	al,'F'
	ja	bad_digit
	sub	al,'A'-10
	clc
	ret
bad_digit:
	stc
	ret
convert_hex_digit ENDP
;
; ८ࠧ 2 ᨬ 16-ଠ  1 
; 室: dx -   ப
; 室: al - 
;        cf = 1 -  訡,  = 0
	PUBLIC	hex_to_byte
hex_to_byte PROC NEAR
	push	bx
	push	cx
	mov	bx,dx
	mov	al,[bx]
	call	convert_hex_digit
	jc	bad_hex
	mov	cx,4
	shl	al,cl
	mov	ah,al
	inc	bx
	mov	al,[bx]
	call	convert_hex_digit
	jc	bad_hex
	or	al,ah
	clc
done_hex:
	pop	cx
	pop	bx
	ret
bad_hex:
	stc
	jmp	SHORT done_hex
hex_to_byte ENDP
;
; ⥭ ப
; dx - 㪠⥫   ப:
; 1  - ᫮ ᨬ + 1  
; 2  - ᫮ ⠭ ᨬ
; ( ENTER), 0 -  ⠭ ᨬ
; ff - ⠭ ७ 
	PUBLIC	read_string
	EXTRN	write_char:NEAR
read_string PROC NEAR
	push	ax
	push	bx
	push	si
	mov	si,dx
start_over:
	mov	bx,2
	mov	ah,7
	int	21h
	or	al,al
	jz	extended
not_extended:
	cmp	al,13
	je	end_input
	cmp	al,8
	jne	not_bs
	call	back_space
	cmp	bl,2
	je	start_over
	jmp	SHORT read_next_char
not_bs:
	cmp	al,27
	je	purge_buffer
	cmp	bl,[si]
	ja	signal_error
	mov	[si+bx],al
	inc	bx
	push	dx
	mov	dl,al
	call	write_char
	pop	dx
read_next_char:
	mov	ah,7
	int	21h
	or	al,al
	jne	not_extended
	mov	ah,7
	int	21h
signal_error:
	push	dx
	mov	dl,7
	mov	ah,2
	int	21h
	pop	dx
	jmp	SHORT read_next_char
purge_buffer:
	push	cx
	mov	cl,[si]
	xor	ch,ch
purge_loop:
	call	back_space
	loop	purge_loop
	pop	cx
	jmp	SHORT start_over
extended:
	mov	ah,7
	int	21h
	mov	[si+2],al
	mov	bl,0ffh
	jmp	SHORT end_string
end_input:
	sub	bl,2
end_string:
	mov	[si+1],bl
	pop	si
	pop	bx
	pop	ax
	ret
read_string ENDP
;
; 뢠 ⭠筮 ᫮
; al - ᨬ
; ah - 1 - ⠭ ᨬ  16-᫮
;      0 -  ⠭ ᨬ
;     ff - ⠭ ७ 
	PUBLIC	read_BYTE
read_BYTE PROC NEAR
	push	dx
	mov	char_num_limit,3
	lea	dx,keyboard_input
	call	read_string
	cmp	num_chars_read,1
	je	ascii_input
	jb	no_characters
	cmp	BYTE ptr num_chars_read,0ffh
	je	special_key
	call	string_to_upper
	lea	dx,chars
	call	hex_to_byte
	jc	no_characters
	mov	ah,1
done_read:
	pop	dx
	ret
no_characters:
	or	ah,ah
	jmp	SHORT done_read
ascii_input:
	mov	al,chars
	mov	ah,1
	jmp	SHORT done_read
special_key:
	mov	al,chars[0]
	mov	ah,0ffh
	jmp	SHORT done_read
read_BYTE ENDP
;
; 뢠 筮 ᫮
; ax - ᫮
; cf = 1 -  訡,  = 0
	PUBLIC	read_decimal
read_decimal PROC NEAR
	push	bx
	push	cx
	push	dx
	mov	char_num_limit,5
	lea	dx,keyboard_input
	call	read_string
	mov	cl,num_chars_read
	xor	ch,ch
	cmp	cl,0
	jle	bad_decimal_digit
	xor	ax,ax
	xor	bx,bx
convert_digit:
	mov	dx,10
	mul	dx
	jc	bad_decimal_digit
	mov	dl,chars[bx]
	sub	dl,'0'
	js	bad_decimal_digit
	cmp	dl,9
	ja	bad_decimal_digit
	add	ax,dx
	inc	bx
	loop	convert_digit
	clc
done_decimal:
	pop	dx
	pop	cx
	pop	bx
	ret
bad_decimal_digit:
	stc
	jmp	SHORT done_decimal
read_decimal ENDP
;
; ࠥ ᨬ  ࠭
;  
	PUBLIC	back_space
	EXTRN	write_char:NEAR
back_space PROC NEAR
	push	ax
	push	dx
	cmp	bx,2
	je	end_bs
	dec	bx
	mov	ah,2
	mov	dl,8
	int	21h
	mov	dl,20h
	call	write_char
	mov	dl,8
	int	21h
end_bs: pop	dx
	pop	ax
	ret
back_space ENDP
code_seg ENDS
data_seg SEGMENT PUBLIC
keyboard_input	LABEL	BYTE
char_num_limit	DB	0
num_chars_read	DB	0
chars		DB	5 DUP(0)
data_seg ENDS
	END